;--------------------------------------------------
; Commodore 16 and Plus/4
;--------------------------------------------------
; PROMEMORIA
; change: gamesnuber, gamestitles printing,gamecopy
; games'titles, games'blocks, hi ROM addresses,
; include .asm, set screen start; if one game is 
; >16kB, copy the first block in hi to lo as last.
;--------------------------------------------------
screen       = $0d68
get          = $ffe4
tapebuf      = $0332
tedback      = $ff15  
tedcol1      = $ff16  
tedcol2      = $ff17  
tedcol3      = $ff18  
tedborder    = $ff19
row          = $d8
s_lo         = $d9
s_hi         = $da
t_lo         = $db
t_hi         = $dc 
blocks       = $dd

gamesnumber = 3

	org $8000-2
	dw  $8000

	jmp $800a
	jmp $800a
 db $01,$43,$42,$4d     ; module-nr., "CBM"
                 sei
                 lda $fb
                 pha
                 ldx #$02       ; cartrige 1 lo, kernal
                 sta $fdd0,x
                 jsr $ff84      ; Initialize I/O devices
                 jsr $ff87      ; RAM Test
                 pla
                 sta $fb
                 jsr $ff8a      ; Restore vectors to initial values
                 jsr $ff81      ; Initialize screen editor
                 lda #cartrige & 255 ; cartridge jump in
                 sta $02fe
                 lda #cartrige >> 8
                 sta $02ff
                 lda #$f1       ; irq -> banking-routines
                 sta $0314
                 lda #$fc
                 sta $0315
                 cli
                 jmp *

cartrige

;--------------------------------------------------
; build screen and setups
;--------------------------------------------------

                 ldx #$ff               
                 stx $ff0c
                 stx $ff0d           ; hide cursor
                 inx
                 stx tedback
                 stx tedborder
                 stx row
;----print text                
                 ldx #$28*3-1
loop1            lda upper_text,x
                 sta $0c00,x
                 lda lower_text,x
                 sta $0ef8,x
                 dex
                 bpl loop1
                 ldx #$28*2-20
loop17           lda bottom_text,x
                 sta $0fa3,x
                 dex
                 bpl loop17
;----print games'titles
	         ldx #$15
loop18           lda game1title,x
                 sta screen+$9,x
                 lda game2title,x
                 sta screen+$9+$28,x
                 lda game3title,x
                 sta screen+$9+$28*2,x
;                 lda game4title,x
;                 sta screen+$9+$28*3,x
;                 lda game5title,x
;                 sta screen+$9+$28*4,x
;                 lda game6title,x
;                 sta screen+$9+$28*5,x
;                 lda game7title,x
;                 sta screen+$9+$28*6,x
                 dex
                 bpl loop18
;----selection bar & colors                 
		 ldx #$13
loop2            lda screen+10,x
                 ora #$80
                 sta screen+10,x 
                 dex
                 bpl loop2            
                 lda #screen >> 8
                 sta t_hi
                 lda #(screen & 255) +10
                 sta t_lo    

                 lda #$71
;                 ldx #$00
		 inx
loop3            sta $0800,x   
                 sta $0900,x
                 sta $0a00,x
                 sta $0ae8,x
                 inx
                 bne loop3
                 ldx #$03
loop20           lda fourcolors,x
                 sta $0800+60,x
                 dex
                 bpl loop20
                 
 
;--------------------------------------------------
; keyboard-scanner
;--------------------------------------------------
keys
                 lda #$7f
                 sta $fd30
                 sta $ff08 
;                 lda $ff08 
 db $af,$08,$ff	; LAX $XXYY
                 and #$20              ; c= to select
                 bne forward
                 jmp gamecopy
forward          
;		  lda #$7f
;                 sta $fd30
;                 sta $ff08 
;                 lda $ff08
		 txa
                 and #$10              ; space to move
                 beq down
                 jmp keys
;--------------------------------------------------
; move down
;--------------------------------------------------
down            inc row
                lda row
                cmp #gamesnumber       ; !!! LAST ROW !!!
                bne loop4
;----wrap  
                clc
                ldy #$00   
loop8           lda (t_lo),y
                and #$7f
                sta (t_lo),y
                iny
                bcc loop5
                inc s_hi
loop5           cpy #$14
                bne loop8
                lda #screen >> 8
                sta t_hi
                lda #(screen & 255) +10
                sta t_lo    
                ldy #$00    
loop6           lda (t_lo),y
                ora #$80
                sta (t_lo),y
                iny
                bcc loop7
                inc s_hi
loop7           cpy #$14
                bne loop6  

                lda #$00
                sta row  
                jmp delay 
;----move  
loop4               
                clc
                ldy #$00    
loop16          lda (t_lo),y
                and #$7f
                sta (t_lo),y
                iny
                bcc loop9
                inc t_hi
loop9           cpy #$14
                bne loop16  
                clc
                lda t_lo
                adc #$28
                sta t_lo 
                bcc loop10
                inc t_hi
loop10          clc
                ldy #$00    
loop13          lda (t_lo),y
                ora #$80
                sta (t_lo),y
                iny
                bcc loop11
                inc s_hi
loop11          cpy #$14
                bne loop13  
                jsr delay  
delay  
                ldx #$00
                ldy #$00
loop12          inx
                bne loop12 
                iny
                cpy #$80
                bne loop12                    
                jmp keys                  

;---game select by row
gamecopy         lda row
                 cmp #$00
                 beq game1_copy
                 cmp #$01
                 beq game2_inbetween_copy
;		 beq game2_copy
                 cmp #$02
;		 beq game3_inbetween_copy
                 beq game3_set
;                 cmp #$03
;                 beq game4_set
;                 cmp #$04
;                 beq game5_set
;                 cmp #$05
;                 beq gogame6_set
;                 cmp #$06
;                 beq gogame7_set
                 jmp keys
;gogame3_set	 jmp game3_set
;gogame4_set	 jmp game4_set
;gogame5_set	 jmp game5_set
;gogame6_set	 jmp game6_set
;gogame7_set	 jmp game7_set

;---copy games rom lo
game1_copy       
		 lda #$10
                 sta t_hi  
                 lda #$01
                 sta t_lo  
                 lda #game1 >> 8
                 sta s_hi  
                 lda #game1 & 255
                 sta s_lo  
                 lda #$2d
                 sta blocks 
                 jsr copy-4
                 jmp trampolin_copy
                 
;game2_copy       
;		 lda #$10
;                 sta t_hi  
;                 lda #$01
;                 sta t_lo  
;                 lda #game2 >> 8
;                 sta s_hi  
;                 lda #game2 & 255
;                 sta s_lo  
;                 lda #$10
;                 sta blocks 
;                 jsr copy-4
;                 jmp trampolin_copy

;--- copy games inbetween roms --------------------
; activate this if there's a ROM >16kB
; games which are copied inbetween HI and LO roms
; must be splitted in two chunks which OVERLAP by
; one block placed both in the end of lo and in the
; beginning of hi, but basically in lo only one
; byte as the last in $BF00 is needed.
;--------------------------------------------------
game2_inbetween_copy
		 lda #$10
                 sta t_hi  
                 lda #$01
                 sta t_lo  
                 lda #game2_inbetween >> 8
                 sta s_hi  
                 lda #game2_inbetween & 255
                 sta s_lo  
                 lda #$12	  ; enter the exact blocks!
                 sta blocks 
                 jsr copy-4
                 dec t_hi
                 lda #$c0
                 sta s_hi  
                 lda #$00
                 sta s_lo  
                 lda #$1c	  ; enter the exact blocks!
                 sta blocks
                jmp rom1_tcopy

;--- copy trampolin-code to tape-buffer
trampolin_copy   ldx #$4b         ; copy trampoline-code
                 lda trampolin,x
                 sta tapebuf,x
                 dex
                 bpl trampolin_copy+2      
                 jmp tapebuf
                 
;--- copy games rom hi ----------------------------
; activate this if there are ROMs in hi only       
;--------------------------------------------------
game3_set  
                 lda #$10
                 sta t_hi  
                 lda #$01
                 sta t_lo  
                 lda #$db
                 sta s_hi  
                 lda #$9b
                 sta s_lo  
                 lda #$21	  ; enter the exact blocks!
                 sta blocks
                 jmp rom1_tcopy
                 
;game4_set  
;                 lda #$10
;                 sta t_hi  
;                 lda #$01
;                 sta t_lo  
;                 lda #$ea
;                 sta s_hi  
;                 lda #$a3
;                 sta s_lo  
;                 lda #$11	  ; enter the exact blocks!
;                 sta blocks
;                 jmp rom1_tcopy                                         

;--- copy trampolin code for rom hi
rom1_tcopy
		 ldx #$00
		 ldy #$00 
loop14           lda rom1_trampolin,x
                 sta tapebuf,x
                 inx     
                 cpx #$1a              
                 bne loop14    
loop15           lda trampolin,y
                 sta tapebuf,x
                 inx
                 iny
                 cpx #$5a                
                 bne loop15     
                 jmp tapebuf

;--- trampolin-code
trampolin        
                 sei 
                 lda #$00
                 sta $02fe       
                 sta $02ff
                 lda #$a4         ;  nativ irq 
                 sta $0314
                 lda #$f2
                 sta $0315
                 lda #$00         ; basic , kernal
                 sta $fdd0        ; function rom off
                 sta $fb
                 lda $fb  
                 jsr $ff84        ; Initialize I/O devices 
;--- reset values and restart ROMs
                 jsr $ff8a        ; Restore vectors to initial values
                 jsr $8117        ; restore vectors !
                 jsr $ff81        ; Initialize screen editor  
                 cli
                 jsr $802e        ; init Basic RAM
                 jsr $8818        ; prg link
                 jsr $8bbe        ; prg mode  
                 lda #$03         ; hide cursor
                 sta $ff0c
                 ora #$ff
                 sta $ff0d      
                 jsr $8bea        ; start prg          
                 rts

;--- switch rom hi and copy game to ram
rom1_trampolin
                 sei
                 ldx #$08
                 sta $fdd0,x      ; cartrige 1 hi, basic
                 ldx #$00
                 ldy #$00
copy             lda (s_lo),y     ; copy game or tool to ram 
                 sta (t_lo),y
                 iny
                 bne copy
                 inc s_hi
                 inc t_hi
                 inx          
                 cpx blocks
                 bne copy
; not included in the tapebuf rom1_tcopy but
; used by the copy subroutine for rom lo
                 rts
fourcolors
 db $4d,$4f,$77,$42

upper_text
 db $20,$55,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43
 db $43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43
 db $43,$43,$43,$43,$43,$43,$49,$20,$20,$47,$20,$03,$0F,$0D,$0D,$0F
 db $04,$0F,$12,$05,$20,$10,$0C,$15,$13,$2F,$34,$20,$A0,$A0,$A0,$A0
 db $20,$20,$33,$32,$0B,$20,$07,$01,$0D,$05,$02,$0F,$18,$20,$48,$20
 db $20,$4A,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43
 db $43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43
 db $43,$43,$43,$43,$43,$43,$4B,$20
 
lower_text
 db $20,$20,$20,$20,$43,$43,$43,$43
 db $43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43
 db $43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$20,$20,$20,$20
 db $20,$20,$20,$20,$13,$10,$01,$03,$05,$20,$14,$0F,$20,$13,$05,$0C
 db $05,$03,$14,$2C,$20,$01,$0E,$04,$20,$03,$3D,$20,$14,$0F,$20,$13,$14
 db $01,$12,$14,$20,$20,$20,$20,$20,$20,$20,$20,$43,$43,$43,$43
 db $43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43
 db $43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$43,$20,$20,$20,$20                  

bottom_text
 db $0C,$15,$03,$01,$2F,$06,$09,$12,$05,$20,$28,$03,$29
 db $20,$32,$30,$32,$31,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
 db $20,$20,$20,$20,$20,$20,$20,$20,$0F,$12,$09,$07,$09,$0E,$01,$0C,$20,$02
 db $19,$20,$20,$03,$02,$0D,$08,$01,$12,$04,$17,$01,$12,$05,$2E,$04,$05
 

; [       GAME1        ]
game1title
 db $1B,$20,$20,$12,$0F,$02,$0F,$20,$0B,$0E,$09,$07,$08,$14,$20,$2B,$34,$0D,$20,$20,$20,$1D
game2title 
 db $1B,$20,$20,$20,$16,$0F,$09,$04,$12,$15,$0E,$0E,$05,$12,$20,$2B,$33,$20,$20,$20,$20,$1D
game3title
 db $1B,$20,$20,$20,$20,$20,$20,$13,$09,$04,$05,$0C,$13,$01,$20,$20,$20,$20,$20,$20,$20,$1D
;game4title
; db $1B,$20,$20,$20,$20,$20,$14,$12,$5,$5,$20,$13,$F,$D,$5,$20,$20,$20,$20,$20,$20,$1D
;game5title
; db $1B,$20,$20,$20,$20,$20,$20,$20,$20,$32,$30,$34,$38,$20,$20,$20,$20,$20,$20,$20,$20,$1D
;game6title 
; db $1B,$20,$20,$20,$20,$20,$20,$20,$17,$08,$01,$03,$0B,$20,$20,$20,$20,$20,$20,$20,$20,$1D
;game7title 
; db $1B,$20,$20,$20,$20,$0A,$01,$0D,$20,$17,$09,$14,$08,$20,$14,$05,$04,$20,$20,$20,$20,$1D  


game1
	include "robo_knight_+4m.asm"

;game2
;	include "quadrillion.asm"
	
game2_inbetween	
	include "voidrunner_+3_lo.asm"
	